local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- Implement a dummy TTD function if we do not get one from another module
if type(s.TimeToDie) ~= 'function'  then
	a.print(L["No TimeToDie function found, using a dummy function. Consider installing Pusikas' Spellflash: TTD."])
	s.TimeToDie = function(unit)
		return 10
	end
end

local regenRate
a.energyRegeneration = function()
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	if s.Buff(115288--[[Energizing Brew]], "player") then
		regenRate = regenRate + 10
	end
	return tonumber(regenRate)
end

local HasteCDs = {
	2825--[[Bloodlust]],
	3045--[[Rapid Fire]],
	26297--[[Berserking]],
	32182--[[Heroism]],
	49016--[[Unholy Frenzy]],
	80353--[[Time Warp]],
	90355--[[Ancient Hysteria]],
	146555--[[Drums of Rage]],
	160452--[[Netherwinds]],
}
a.Hasted = function()
	return s.Buff(HasteCDs, "player")
end

-- Detect raid-wide haste buffs, so we know when to
-- use potions
local BloodlustSpells = {
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	80353--[[Time Warp]],
	90355--[[Ancient Hysteria]],
	146555--[[Drums of Rage]],
	160452--[[Netherwinds]],
}
a.Bloodlust = function()
	return s.Buff(BloodlustSpells, "player")
end

local myself

a.IncomingDamage = {}
a.AoE = {}
x.CombatStart = 0

local CurrentTimestamp = 0
local event, sourceGUID, destGUID, destFlags, spellId, spellName, amount
local arrayIndex = 0
local tsIndex = 0
local myLastDamageTaken = time()
local target_is_outsider

local function clear()
	for i = 1, 15, 1 do
		a.IncomingDamage[i] = 0
	end
end
clear()

a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, _, _, _, destGUID, _, destFlags, _, spellId, spellName = ...
	myself = UnitGUID("player")
	tsIndex = mod(floor(CurrentTimestamp * 10), 15) + 1
	target_is_outsider = bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	
	if tsIndex > arrayIndex then
	-- the new index comes after the old index. we have to clear all array entries between them.
		for i = arrayIndex + 1, tsIndex, 1 do
			a.IncomingDamage[i] = 0
		end
		arrayIndex = tsIndex
	elseif tsIndex < arrayIndex then
	-- the new index comes before the old index. we have to clear till the end of the array and then
	-- from the start up to the new index.
		for i = arrayIndex + 1, 15, 1 do
			a.IncomingDamage[i] = 0
		end
		for i = 1, tsIndex, 1 do
			a.IncomingDamage[i] = 0
		end
		arrayIndex = tsIndex
	end
	
	if event == "UNIT_DIED" or event == "UNIT_DESTROYED" then
		a.AoE[destGUID] = nil
	elseif sourceGUID == myself and destGUID ~= myself and target_is_outsider and (string.find(event, "_DAMAGE") or string.find(event, "_MISSED")) then
		a.AoE[destGUID] = CurrentTimestamp
	end
	
	if destGUID == myself and string.find(event, "_DAMAGE") then
		myLastDamageTaken = CurrentTimestamp
		if destGUID == myself and (event == "SWING_DAMAGE") then
			amount = select(12, ...)
			a.IncomingDamage[arrayIndex] = a.IncomingDamage[arrayIndex] + amount
		else
			amount = select(15, ...)
			a.IncomingDamage[arrayIndex] = a.IncomingDamage[arrayIndex] + amount
		end
	end
end

a.leaveCombat = function()
	x.CombatStart = 0
end

a.enterCombat = function()
	x.CombatStart = GetTime()
end

-- register events
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_ENABLED", a.leaveCombat)
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_DISABLED", a.enterCombat)
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)

-- Check if we are in AoE mode
function a.ActiveEnemies()
	local now = time()
	local i = 0
	foreach(a.AoE, function(k, v)
		if v and now - v > 3 then
			a.AoE[k] = nil
		else
			i = i + 1
		end
	end)
	return i
end

function a.getStagger()
	local name, val2
	name,_,_,_,_,_,_,_,_,_,_,_,_,_,_,val2 = UnitAura("player", s.SpellName(124275--[[Light Stagger]]), nil, "HARMFUL")
	if name then
		return val2
	end
	name,_,_,_,_,_,_,_,_,_,_,_,_,_,_,val2 = UnitAura("player", s.SpellName(124274--[[Moderate Stagger]]), nil, "HARMFUL")
	if name then
		return val2
	end
	name,_,_,_,_,_,_,_,_,_,_,_,_,_,_,val2 = UnitAura("player", s.SpellName(124273--[[Heavy Stagger]]), nil, "HARMFUL")
	if name then
		return val2
	end
	return 0
end

function a.incomingDamage1500ms()
	local i
	local ret = 0
	for i = 1, 15, 1 do
		ret = ret + a.IncomingDamage[i]
	end
	return ret
end